use std::sync::Arc;

use tokio::sync::{ mpsc, Mutex};

use crate::message::Message;

#[derive(Clone)]
pub struct GameController {
    pub channels: Arc<Mutex<Vec<Channel>>>,
}

impl std::default::Default for GameController {
    fn default() -> Self {
        let channels = Arc::new(Mutex::new(Vec::new()));
        GameController { channels }
    }
}

pub struct Channel {
    pub tx: mpsc::Sender<Message>,
    pub rx: mpsc::Receiver<Message>,
}

pub fn channel_pair() -> (Channel, Channel) {
    let (atx, brx) = mpsc::channel(32);
    let (btx, arx) = mpsc::channel(32);
    (Channel { tx: atx, rx: arx }, Channel { tx: btx, rx: brx })
}

impl GameController {
    pub async fn run_loop(&self) {
        todo!();
    }
}
