use std::collections::HashMap;
use std::sync::Arc;

use tokio::sync::Mutex;

pub mod game;
pub mod message;
pub mod client;

use game::GameController;
mod code_generator;
use code_generator::CodeGenerator;

#[derive(Default)]
pub struct GlobalState {
    pub code_generator: Arc<Mutex<CodeGenerator>>,
    pub rooms: Arc<Mutex<HashMap<String, GameController>>>,
}
